PETSc version 3.15.5
Fix/Edit manual page

# MatDiagonalSet

Computes Y = Y + D, where D is a diagonal matrix that is represented as a vector. Or Y[i,i] = D[i] if InsertMode is INSERT_VALUES.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatDiagonalSet(Mat Y,Vec D,InsertMode is)

Neighbor-wise Collective on Mat

### Input Parameters

| Y | - the input matrix
| D | - the diagonal matrix, represented as a vector
| i | - INSERT_VALUES or ADD_VALUES

### Notes

If the matrix Y is missing some diagonal entries this routine can be very slow. To make it fast one should initially fill the matrix so that all diagonal entries have a value (with a value of zero for those locations that would not have an entry).

### See Also

MatShift(), MatScale(), MatDiagonalScale()

### Level

intermediate

### Location

src/mat/utils/axpy.c

### Examples

src/ts/tutorials/ex50.c.html
src/tao/constrained/tutorials/tomographyADMM.c.html
src/tao/pde_constrained/tutorials/elliptic.c.html
src/tao/tutorials/ex4.c.html

### Implementations

MatDiagonalSet_MPIAIJ in src/mat/impls/aij/mpi/mpiaij.c
MatDiagonalSet_SeqAIJ in src/mat/impls/aij/seq/aij.c
MatDiagonalSet_IS in src/mat/impls/is/matis.c
MatDiagonalSet_Nest in src/mat/impls/nest/matnest.c
MatDiagonalSet_MPISELL in src/mat/impls/sell/mpi/mpisell.c
MatDiagonalSet_Shell in src/mat/impls/shell/shell.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages